<?php

declare(strict_types=1);

namespace Dedi\SyliusQuotePlugin\Processor\Quote;

use Dedi\SyliusQuotePlugin\Entity\QuoteInterface;
use Dedi\SyliusQuotePlugin\Entity\QuoteItemInterface;
use Sylius\Component\Core\Calculator\ProductVariantPricesCalculatorInterface;

class QuotePricesRecalculator implements QuoteProcessorInterface
{
    private ProductVariantPricesCalculatorInterface $productVariantPricesCalculator;

    public function __construct(ProductVariantPricesCalculatorInterface $productVariantPricesCalculator)
    {
        $this->productVariantPricesCalculator = $productVariantPricesCalculator;
    }

    public function process(QuoteInterface $quote): void
    {
        $channel = $quote->getChannel();

        /** @var QuoteItemInterface $item */
        foreach ($quote->getItems() as $item) {
            $item->setUnitPrice($this->productVariantPricesCalculator->calculate(
                $item->getVariant(),
                ['channel' => $channel]
            ));
        }
    }
}
